% makeall_inputs defines all the inputs for the simulation of the FEF.
% These inputs are: Dorsal visual input and Fixation input to FEF; 
% Ventral feature specific input to Recognition Module.
%
% created: Jakob Heinzle 01/07

clear inputs
inputs.ninputs=0;


% Add the visual input to layer 4
name='VisualInput';type='exc';to='E4';inarray=inarray1;retinotopic=1;
MeanInp=0.056;NoiseLevel=1;t_on=tvisual_on;t_trans_off=tvisual_transoff;t_off=tvisual_off;sustained_level=0.5;
add_input;

% Add the fixation input to fixation neurons
name='FixationInput';type='exc';to='IFIX';inarray=1;retinotopic=0;
MeanInp=0.2;NoiseLevel=1;t_on=tfix_on;t_trans_off=tmax;t_off=tfix_off;sustained_level=1;
add_input;

% general inputs, e.g. to layer 6R foveal
name='Layer6Fovea';type='exc';to='E6R';inarray=zeros(1,21);inarray(11)=1;retinotopic=0;
MeanInp=0.3;NoiseLevel=1;t_on=0;t_trans_off=tmax;t_off=tmax;sustained_level=1;
add_input;

% Short Word feature detectors.
name='W1Feature';type='exc';to='EW1';inarray=(featarray==11);retinotopic=1;
MeanInp=0.178;NoiseLevel=0;t_on=1;t_trans_off=tmax;t_off=tmax;sustained_level=1;
add_input;

% Pro-Saccade feature detectors.
name='W2Feature';type='exc';to='EW2';inarray=(featarray==12);retinotopic=1;
MeanInp=0.178;NoiseLevel=0;t_on=1;t_trans_off=tmax;t_off=tmax;sustained_level=1;
add_input;

% Pro-Saccade feature detectors.
name='W3Feature';type='exc';to='EW3';inarray=(featarray==13);retinotopic=1;
MeanInp=0.178;NoiseLevel=0;t_on=1;t_trans_off=tmax;t_off=tmax;sustained_level=1;
add_input;

% Space feature detectors. Used to recognize spaces at the fovea.
name='SpaceFeature';type='exc';to='EFspace';inarray=(inarray1(11)==0);retinotopic=0;
MeanInp=0.178;NoiseLevel=0;t_on=tvisual_on;t_trans_off=tvisual_off;t_off=tvisual_off;sustained_level=1;
add_input;

% Short input to Layer2/3 at the beginning to put attention on fovea.
name='AttentionFovea';type='exc';to='E23';inarray=zeros(1,21);inarray(11)=1; retinotopic=0;
MeanInp=0.1;NoiseLevel=0;t_on=30;t_trans_off=50;t_off=50;sustained_level=1;
add_input;
